F - Prime Path //BFS 广度优先搜索

F - Prime Path


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

    sprintf(s,"%d",n);

 参考网址:   点击打开链接

   sscanf(s,"%d",&n);

从字符串s中取一个整数值到变量n中。


过程:每一位数字都从1-9枚举一次,如果是素数,就再次枚

举,直到找到目标答案。

#include<stdio.h>
#include<stdlib.h>
#include<iostream>
#include<algorithm>
#include<string.h>
#include<queue>
#include<math.h>
using namespace std;
const int N=10000;
int prime[N];
int s;
int e;
int vis[N];
int Prime(int x)
{
   for(int i=2;i<=sqrt(x);i++)
   {
   	  if(x%i==0)
   	   return 0;
   }
    return 1;
}
int change(int n,int k) // 把n的第k位转化为0; 
{
	char s[10]={0};
	sprintf(s,"%d",n);  //把整数n 打印成一个字符串保存在s 中 
//参考网址:http://blog.sina.com.cn/s/blog_980cf62a0100ya0z.html 
	s[k]='0';
	sscanf(s,"%d",&n);  // 从字符串s中取一个整数值到变量n中。
   return n;
}
int bfs(int s, int e)
{
	int q,w,r;
	memset(vis,0,sizeof(vis));
	queue<int>Q;
	Q.push(s);
	vis[s]=1;
	while(Q.size())
	{
		s=Q.front();
		Q.pop();
		if(s==e)
		{
		   return vis[s]-1;	
	    }
	       w=1000;
	       for(int i=0;i<4;i++)
	       {
	       	 q=change(s,i);
	       	 for(int j=0;j<10;j++)
	       	 {
	       	     r=q+j*w;
	       	     if(prime[r]==1 && vis[r]==0 )
	       	     {
	       	     	 Q.push(r);
	       	     	 vis[r]=vis[s]+1;
				 }
			 }
			 w=w/10;
		   }
		}
	return -1;
}
int main()
{
	int T;
	for(int i=1000;i<10000;i++)
	 prime[i]=Prime(i);
	scanf("%d",&T);
	while(T--)
	{
		scanf("%d%d",&s,&e); //不要忘记加 & 符号 细节决定成败 
		if(bfs(s,e)==-1)
		{
		  printf("Impossible\n");	
		}
		else
		{
			printf("%d\n",bfs(s,e));
		}
	}
	return 0;
}



猜你喜欢

转载自blog.csdn.net/lmengi000/article/details/80375661